<?php
 // === Trait TraitControl ===
 trait TraitControl {
  protected function AfficheAdresse() {
   echo get_called_class().'-Accès à l\'entreprise par le: ';
   echo $this->AdresseAcces.PHP_EOL;
  }
 }
 // === Classe Personnel ===
 class Personnel {
  private $AdresseAcces="21 rue Blum";
  use TraitControl {
   AfficheAdresse as public;
  }
 }
 // === Classe Livraison ===
 class Livraison {
  private $AdresseAcces="Quai de numéro 2";
  use TraitControl {
   AfficheAdresse as public;
  }
 }
 // === Programme ===
 // Création salarié et affichage porte d'accès
 $UnSalarie = new Personnel()   ;
 $UnSalarie->AfficheAdresse()   ; 
 // Création salarié et affichage porte d'accès
 $UneLivraison = new Livraison();
 $UneLivraison->AfficheAdresse(); 
?>